/* AMX Mod X
*   Crysis NanoSuit 1.0
*
* (c) Copyright 2008 by =[UnO]=P@c|Man
* (c) Sounds are property of Crytek
*
* This file is provided as is (no warranties)
*
*     DESCRIPTION
*	Use the Crysis NanoSuit in Counter-Strike 1.6 and CZ. You can choose between
*	"Maximum Strength", "Maximum Armor", "Maximum Speed" and "Cloak Mode".
*
*	Maximum Strength:
*		- jump higher - critical attack: 50% chance - breakable objects will break (glass)
*		- touching hostages, teammates and enemies might kill them
*	Maximum Armor: 	- slower - block attack: 99% chance
*	Maximum Speed: 	- faster
*	Cloak Mode:	- invisibilty
*
*	All of these mods costs energy. Stand still to regenerate energy.
*
*     COMMANDS
*	nanosuit:	open NanoSuit menu
*	help:		show MOTD (help file)
*
*     CVARS
*	NanoSuit_Price:		price of NanoSuit (default: 0)
*	NanoSuit_Energy:	maximum energy
*	NanoSuit_Critical:	sound "energy critical" appear when energy is lower than...
*	NanoSuit_Health:	default health, when using NanoSuit
*	NanoSuit_Armor:		default armor, when using NanoSuit
*	NanoSuit_Regenerate:	energy per second (twice as much, if no function is activated)
*
*	NanoSuit_Strength_Gravity:	gravity when using "Maximum Strength"
*	NanoSuit_Strength_Energy:	"price" of critical attack
*	NanoSuit_Strength_Jump:		"price" of jumping
*	NanoSuit_Strength_Destroy:	"price" of destroying breakable objects / touching players
*
*	NanoSuit_Armor_Armor:	armor when using "Maximum Armor"
*	NanoSuit_Armor_Energy:	"price" for blocking attack
*	NanoSuit_Armor_Speed:	speed when using "Maximum Armor"
*
*	NanoSuit_Speed_Speed:	speed when using "Maximum Speed"
*	NanoSuit_Speed_Energy:	"price" for being fast (when moving; per second)
*
*	NanoSuit_Cloak_Alpha:	alpha value when using "Cloak Mode"
*	NanoSuit_Cloak_Energy:	"price" for being invisible (when moving; per second)
*
*     CREDITS
*       All who had the idea for this mod;
*	All users of AlliedModders;
*/


#include <amxmodx>
#include <fakemeta_util>
#include <hamsandwich>

#define PLUGIN "Crysis NanoSuit"
#define VERSION "1.0"
#define AUTHOR "=[UnO]=P@c|Man"

// Default Settings
new NanoSuit_Price[] = "0";
new NanoSuit_Energy[] = "100";
new NanoSuit_Critical[] = "10";
new NanoSuit_Health[] = "400";
new NanoSuit_Armor[] = "200";
new NanoSuit_Regenerate[] = "2";

new NanoSuit_Strength_Gravity[] = "0.5";
new NanoSuit_Strength_Energy[] = "6";
new NanoSuit_Strength_Jump[] = "15";
new NanoSuit_Strength_Destroy[] = "10";

new NanoSuit_Armor_Armor[] = "999";
new NanoSuit_Armor_Energy[] = "4";
new NanoSuit_Armor_Speed[] = "150";

new NanoSuit_Speed_Speed[] = "450";
new NanoSuit_Speed_Energy[] = "6";

new NanoSuit_Cloak_Alpha[] = "16";
new NanoSuit_Cloak_Energy[] = "3";

// PCVar
new pcNanoSuit_Price, pcNanoSuit_Energy, pcNanoSuit_Critical;
new pcNanoSuit_Health, pcNanoSuit_Armor, pcNanoSuit_Regenerate;
new pcNanoSuit_Strength_Gravity, pcNanoSuit_Strength_Energy;
new pcNanoSuit_Strength_Jump, pcNanoSuit_Strength_Destroy;
new pcNanoSuit_Armor_Armor, pcNanoSuit_Armor_Energy;
new pcNanoSuit_Armor_Speed;
new pcNanoSuit_Speed_Speed, pcNanoSuit_Speed_Energy;
new pcNanoSuit_Cloak_Alpha, pcNanoSuit_Cloak_Energy;

// Sounds
new const NanoSuit_Sounds_Strengh[] = "nanosuit/nanosuit_strength.wav";
new const NanoSuit_Sounds_Armor[] = "nanosuit/nanosuit_armor.wav";
new const NanoSuit_Sounds_Speed[] = "nanosuit/nanosuit_speed.wav";
new const NanoSuit_Sounds_Cloak[] = "nanosuit/nanosuit_cloak.wav";
new const NanoSuit_Sounds_Energy[] = "nanosuit/nanosuit_energy.wav";

// Models
// new const NanoSuit_Knife[] = "models/nanosuit/v_knife.mdl";

// Menu
new NanoSuit_Menu;

// Player
new NanoSuit_Player_HasNano[33];
new NanoSuit_Player_Energy[33];
new NanoSuit_Player_Active[33];
new NanoSuit_Player_Warned[33];
new NanoSuit_Player_Speed[33];

// for Messages
new NanoSuit_HudSync;


// Plugin/Server Functions
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);

	register_event("ResetHUD", "newRound", "be");
	//register_event("CurWeapon", "setModel", "be");
	RegisterHam(Ham_TakeDamage, "player", "NanoSuit_TakeDamage");
	
	register_clcmd("say nanosuit", "NanoSuit_Menu_Show");
	register_clcmd("nanosuit", "NanoSuit_Menu_Show");
	register_clcmd("say help", "NanoSuit_Help");
	register_clcmd("help", "NanoSuit_Help");

	pcNanoSuit_Price	= register_cvar("NanoSuit_Price", NanoSuit_Price);
	pcNanoSuit_Energy	= register_cvar("NanoSuit_Energy", NanoSuit_Energy);
	pcNanoSuit_Critical	= register_cvar("NanoSuit_Critical", NanoSuit_Critical);
	pcNanoSuit_Health	= register_cvar("NanoSuit_Health", NanoSuit_Health);
	pcNanoSuit_Armor	= register_cvar("NanoSuit_Armor", NanoSuit_Armor);
	pcNanoSuit_Regenerate	= register_cvar("NanoSuit_Regenerate", NanoSuit_Regenerate);

	pcNanoSuit_Strength_Gravity	= register_cvar("NanoSuit_Strength_Gravity", NanoSuit_Strength_Gravity);
	pcNanoSuit_Strength_Energy	= register_cvar("NanoSuit_Strength_Energy", NanoSuit_Strength_Energy);
	pcNanoSuit_Strength_Jump	= register_cvar("NanoSuit_Strength_Jump", NanoSuit_Strength_Jump);
	pcNanoSuit_Strength_Destroy	= register_cvar("NanoSuit_Strength_Destroy", NanoSuit_Strength_Destroy);

	pcNanoSuit_Armor_Armor	= register_cvar("NanoSuit_Armor_Armor", NanoSuit_Armor_Armor);
	pcNanoSuit_Armor_Energy	= register_cvar("NanoSuit_Armor_Energy", NanoSuit_Armor_Energy);
	pcNanoSuit_Armor_Speed	= register_cvar("NanoSuit_Armor_Speed", NanoSuit_Armor_Speed);

	pcNanoSuit_Speed_Speed	= register_cvar("NanoSuit_Speed_Speed", NanoSuit_Speed_Speed);
	pcNanoSuit_Speed_Energy	= register_cvar("NanoSuit_Speed_Energy", NanoSuit_Speed_Energy);

	pcNanoSuit_Cloak_Alpha	= register_cvar("NanoSuit_Cloak_Alpha", NanoSuit_Cloak_Alpha);
	pcNanoSuit_Cloak_Energy	= register_cvar("NanoSuit_Cloak_Energy", NanoSuit_Cloak_Energy);

	register_forward(FM_PlayerPreThink, "fw_preThink");
	register_forward(FM_Touch, "fw_Touch");
	register_forward(FM_GetGameDescription, "GameDesc");

	NanoSuit_Menu_Create();

	// Show Status on Screen
	NanoSuit_HudSync = CreateHudSyncObj();

	new Monitor = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));

	if (Monitor)
	{
		set_pev(Monitor, pev_classname, "MonitorLoop");
		set_pev(Monitor, pev_nextthink, get_gametime() + 0.1);

		register_forward(FM_Think, "showActMode");
	}

	set_task(300.0, "NanoSuit_Advertisement");
}

public plugin_precache() {
	precache_sound(NanoSuit_Sounds_Strengh);
	precache_sound(NanoSuit_Sounds_Armor);
	precache_sound(NanoSuit_Sounds_Speed);
	precache_sound(NanoSuit_Sounds_Cloak);
	precache_sound(NanoSuit_Sounds_Energy);

	// precache_model(NanoSuit_Knife)
}

// Description
public GameDesc() { 
	forward_return(FMV_STRING, PLUGIN);
	
	return FMRES_SUPERCEDE;
}

public client_connect(id) {
	NanoSuit_Player_HasNano[id] = 0;
	NanoSuit_Player_Active[id] = -3;
}

// NanoSuit_Menu
public NanoSuit_Menu_Create() {
	NanoSuit_Menu = menu_create("NanoSuit - Functions", "NanoSuit_Menu_Choose");

	menu_additem(NanoSuit_Menu, "Maximum Strength");
	menu_additem(NanoSuit_Menu, "Maximum Armor");
	menu_additem(NanoSuit_Menu, "Maximum Speed");
	menu_additem(NanoSuit_Menu, "Cloak Mode");

	menu_setprop(NanoSuit_Menu, MPROP_EXIT, MEXIT_ALL);
	menu_setprop(NanoSuit_Menu, MPROP_EXITNAME, "None");

	return PLUGIN_CONTINUE;
}

public NanoSuit_Menu_Show(id) {
	if (!is_user_alive(id))
		return PLUGIN_HANDLED;

	if (NanoSuit_Player_HasNano[id] == 1)
		menu_display(id, NanoSuit_Menu);
	else {
		new money = fm_get_user_money(id);
		new price = get_pcvar_num(pcNanoSuit_Price);

		if (money > price)
		{
			NanoSuit_Player_HasNano[id] = 1;

			fm_set_user_money(id, money - price);
			fm_set_user_health(id, get_pcvar_num(pcNanoSuit_Health));

			NanoSuit_Reset(id);
			
			client_print(id, print_center, "NanoSuit - Activated");
			menu_display(id, NanoSuit_Menu);
		}
	}

	return PLUGIN_HANDLED;
}

public NanoSuit_Menu_Choose(id, menu, item) {
	NanoSuit_Player_Active[id] = item;

	switch (item)
	{
		case 0: client_cmd(id, "spk %s", NanoSuit_Sounds_Strengh);
		case 1: client_cmd(id, "spk %s", NanoSuit_Sounds_Armor);
		case 2: client_cmd(id, "spk %s", NanoSuit_Sounds_Speed);
		case 3: client_cmd(id, "spk %s", NanoSuit_Sounds_Cloak);
	}

	showActivateMessage(id);

	return PLUGIN_HANDLED;
}

// NanoSuit_Reset
public NanoSuit_Reset(id) {
	fm_set_user_health(id, get_pcvar_num(pcNanoSuit_Health))

	NanoSuit_Player_Active[id] = -3;
	NanoSuit_Player_Energy[id] = get_pcvar_num(pcNanoSuit_Energy);
	NanoSuit_Player_Warned[id] = 0;
	NanoSuit_Player_Speed[id] = 0;

	fw_preThink(id);

	remove_task(id);
	set_task(1.0, "setEnergy", id);

	return PLUGIN_CONTINUE;
}

// NanoSuit_Strength
public NanoSuit_Strength_Set(id) {
	if (NanoSuit_Player_Active[id] == 0)
		set_pev(id, pev_gravity, get_pcvar_float(pcNanoSuit_Strength_Gravity));
	else
		set_pev(id, pev_gravity, 1.0);

	return PLUGIN_CONTINUE;
}

// Touch
public fw_Touch(ent, id) {
	if (ent == 0 || id > 32 || id < 1)
		return FMRES_HANDLED;

	if (!is_user_alive(id) || !NanoSuit_Player_HasNano[id])
		return FMRES_HANDLED;

	if (NanoSuit_Player_Active[id] == 0)
	{		
		new entClass[64];

		pev(ent, pev_classname, entClass, 63);

		if (equali(entClass, "func_breakable") || equali(entClass, "hostage_entity"))
		{
			fm_fakedamage(ent, entClass, 5.0, DMG_BULLET);
			setEnergy(id, get_pcvar_num(pcNanoSuit_Strength_Destroy));
		}

		if (equali(entClass, "player") && is_user_alive(ent))
		{
			fm_fakedamage(ent, entClass, 5.0, DMG_BULLET);
			setEnergy(id, get_pcvar_num(pcNanoSuit_Strength_Destroy));
		}
	}

	return FMRES_HANDLED
}

// NanoSuit_Armor
public NanoSuit_Armor_Set(id) {
	if (NanoSuit_Player_Active[id] == 1)
	{
		if (fm_get_user_maxspeed(id) < get_pcvar_float(pcNanoSuit_Armor_Speed))
			if (fm_get_user_maxspeed(id) != 1)
				fm_set_user_maxspeed(id, get_pcvar_float(pcNanoSuit_Armor_Speed));

		fm_set_user_armor(id, get_pcvar_num(pcNanoSuit_Armor_Armor));
	} else {
		if (NanoSuit_Player_Active[id] != 2 && fm_get_user_maxspeed(id) != 1)
			if (fm_get_user_maxspeed(id) < 250.0)
				fm_set_user_maxspeed(id, 250.0);

		fm_set_user_armor(id, get_pcvar_num(pcNanoSuit_Armor));
	}
		
	return PLUGIN_CONTINUE;
}

// NanoSuit_TakeDamage
public NanoSuit_TakeDamage(idVictim, idInflictor, idAttacker, Float:Damage, DamageBits)
{
	new Float:orgDam = Damage;

	// Strength?
	if (NanoSuit_Player_HasNano[idAttacker] && NanoSuit_Player_Active[idAttacker] == 0)
	{
		if (random_num(1, 2) == 1)
		{
			Damage *= 1.5;
			setEnergy(idAttacker, get_pcvar_num(pcNanoSuit_Strength_Energy));
			
		}
	}

	// Armor?
	if (NanoSuit_Player_HasNano[idVictim] && NanoSuit_Player_Active[idVictim] == 1)
	{
		if (random_num(1, 100) != 1)
		{
			Damage = 0.0;
			setEnergy(idVictim, get_pcvar_num(pcNanoSuit_Armor_Energy));
		}
	}

	if (Damage == orgDam)
		return HAM_IGNORED;

	SetHamParamFloat(4, Damage);

	return HAM_HANDLED;
}

// NanoSuit_Speed
public NanoSuit_Speed_Set(id) {
	if (NanoSuit_Player_Active[id] == 2)
	{
		if (fm_get_user_maxspeed(id) < get_pcvar_float(pcNanoSuit_Speed_Speed))
			if (fm_get_user_maxspeed(id) != 1)
				fm_set_user_maxspeed(id, get_pcvar_float(pcNanoSuit_Speed_Speed));
	} else
		if (NanoSuit_Player_Active[id] != 1)
			if (fm_get_user_maxspeed(id) > 250.0)
				fm_set_user_maxspeed(id, 250.0);

	return PLUGIN_CONTINUE
}

// NanoSuit_Cloak
public NanoSuit_Cloak_Set(id) {
	if (NanoSuit_Player_Active[id] == 3)
		fm_set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, get_pcvar_num(pcNanoSuit_Cloak_Alpha));
	else
		fm_set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255);

	return PLUGIN_CONTINUE;
}

// Activate Message
public showActivateMessage(id) {
	new HUD[64];

	switch (NanoSuit_Player_Active[id])
	{
		case -3: format(HUD, 64, "NanoSuit - Nothing Activated");
		case 0: format(HUD, 64, "NanoSuit - Maximum Strength");
		case 1: format(HUD, 64, "NanoSuit - Maximum Armor");
		case 2: format(HUD, 64, "NanoSuit - Maximum Speed");
		case 3: format(HUD, 64, "NanoSuit - Cloak Engaged");
	}

	client_print(id, print_center, "%s", HUD);

	return PLUGIN_CONTINUE;
}

// ActMode Message
public showActMode(ent) {
	if (!pev_valid(ent))
		return FMRES_IGNORED;

	static class[32];
	pev(ent, pev_classname, class, 31);

	if (equal("MonitorLoop", class, 11))
	{
		static players[32], count, id;
		get_players(players, count, "ac");

		for (new i = 0; i < count; i++)
		{
			id = players[i];

			if (NanoSuit_Player_HasNano[id])
			{
				// Current Mode
				new HUD[200];

				switch (NanoSuit_Player_Active[id])
				{
					case -3: formatex(HUD, 199, "Current Mode: Nothing Activated^n");
					case 0: formatex(HUD, 199, "Current Mode: Maximum Strength^n");
					case 1: formatex(HUD, 199, "Current Mode: Maximum Armor^n");
					case 2: formatex(HUD, 199, "Current Mode: Maximum Speed^n");
					case 3: formatex(HUD, 199, "Current Mode: Cloak Mode^n");
				}

				// Energy
				new actEnergy = NanoSuit_Player_Energy[id];
				new Float:Pro = float(actEnergy) / get_pcvar_float(pcNanoSuit_Energy);
				new fPro = floatround(Pro * 100);
				new nPro = floatround(Pro * 20);

				formatex(HUD, 199, "%sEnergy: (%d\%)", HUD, fPro);

				for (new x = 0; x < nPro; x++)
					formatex(HUD, 199, "%s|", HUD);

				formatex(HUD, 199, "%s^n^n", HUD)

				// Health, Armor, Speed
				formatex(HUD, 199, "%sHealth: %d Armor: %d", HUD, get_user_health(id), get_user_armor(id));

				switch (NanoSuit_Player_Speed[id])
				{
					case 0: formatex(HUD, 199, "%s Speed: Standing", HUD);
					case 1: formatex(HUD, 199, "%s Speed: Very Slow", HUD);
					case 2: formatex(HUD, 199, "%s Speed: Slow", HUD);
					case 3: formatex(HUD, 199, "%s Speed: Fast", HUD);
				}

				set_hudmessage(255, 180, 0, 0.02, 0.72, 0, 0.0, 0.3, 0.0, 0.0);
				ShowSyncHudMsg(id, NanoSuit_HudSync, "%s", HUD);
			} else {
				new HUD[128];

				formatex(HUD, 127, "Type or bind 'nanosuit' to buy a NanoSuit^n");
				formatex(HUD, 127, "%sType 'help' if you need help", HUD);

				set_hudmessage(255, 180, 0, 0.02, 0.72, 0, 0.0, 0.3, 0.0, 0.0);
				ShowSyncHudMsg(id, NanoSuit_HudSync, "%s", HUD);
			}
		}

		set_pev(ent, pev_nextthink, get_gametime() + 0.1);
	}

	return FMRES_IGNORED;
}

// setEnergy
public setEnergy(id, val) {
	new actAct = NanoSuit_Player_Active[id];
	new actEnergy = NanoSuit_Player_Energy[id];

	// Decrease
	if (val != 0)
		actEnergy -= val;
	else
	{
		if (NanoSuit_Player_Speed[id] > 0)
		{
			new Float:multi = 1.0;

			switch (NanoSuit_Player_Speed[id])
			{
				case 2: multi = 1.5;
				case 3: multi = 2.0;
			}

			switch (actAct)
			{
				case 2: actEnergy -= floatround(get_pcvar_num(pcNanoSuit_Speed_Energy) * multi);
				case 3: actEnergy -= floatround(get_pcvar_num(pcNanoSuit_Cloak_Energy) * multi);
			}
		}
	}
	
	if (actEnergy < get_pcvar_num(pcNanoSuit_Critical) && NanoSuit_Player_Warned[id] < 1)
	{
		NanoSuit_Player_Warned[id] = 1;
		client_cmd(id, "spk %s", NanoSuit_Sounds_Energy);
		
	}

	if (actEnergy <= 0)
	{
		actEnergy = 0;

		client_print(id, print_center, "NanoSuit - No Energy");

		NanoSuit_Player_Active[id] = -3;
		actAct = -3;
	}

	// Increase
	if (val == 0 && actEnergy < get_pcvar_num(pcNanoSuit_Energy))
	{
		new newEnergy = get_pcvar_num(pcNanoSuit_Regenerate);

		if (NanoSuit_Player_Active[id] == -3)
			newEnergy *= 2;

		newEnergy += actEnergy;
		actEnergy = min(get_pcvar_num(pcNanoSuit_Energy), newEnergy);

		if (actEnergy > get_pcvar_num(pcNanoSuit_Critical) + 20)
			NanoSuit_Player_Warned[id] = 0;
	}
	
	NanoSuit_Player_Energy[id] = actEnergy;

	if (val == 0)
		set_task(1.0, "setEnergy", id);

	return PLUGIN_CONTINUE;
}

// newRound
public newRound(id) {
	static players[32], count, id;
	get_players(players, count);

	for (new i = 0; i < count; i++)
	{
		id = players[i];

		if (NanoSuit_Player_HasNano[id])
		{
			fm_set_user_health(id, get_pcvar_num(pcNanoSuit_Health));
			fm_set_user_armor(id, get_pcvar_num(pcNanoSuit_Armor));

			NanoSuit_Reset(id);
		}
	}

	return PLUGIN_CONTINUE;
}

// setModel
/* public setModel(id) {
	new weaponID = get_user_weapon(id)

	switch (weaponID)
	{
		case CSW_KNIFE: set_pev(id, pev_viewmodel2, NanoSuit_Knife)
	}

	return PLUGIN_CONTINUE
} */

// Advertisement
public NanoSuit_Advertisement(id) {
	client_print(id, print_chat, "=[UnO]= Crysis NanoSuit (%s) by =[UnO]=P@c|Man", VERSION);
	client_print(id, print_chat, "Type or Bind 'nanosuit', '/help'");
	client_print(id, print_chat, "Visit www.united-outlaws.net");

	set_task(300.0, "NanoSuit_Advertisement");
}

// Forward
public fw_preThink(id) {
	if (!is_user_alive(id))
		return FMRES_IGNORED;

	if (!NanoSuit_Player_HasNano[id])
		return FMRES_IGNORED;
		
	NanoSuit_Strength_Set(id);
	NanoSuit_Armor_Set(id);
	NanoSuit_Speed_Set(id);
	NanoSuit_Cloak_Set(id);

	// Run
	new speed = fm_get_speed(id);

	// slow: >0, normal >50,  fast >150
	if (speed == 0)	NanoSuit_Player_Speed[id] = 0;
	if (speed > 0)	NanoSuit_Player_Speed[id] = 1;
	if (speed > 100)	NanoSuit_Player_Speed[id] = 2;
	if (speed > 150)	NanoSuit_Player_Speed[id] = 3;
	
	// Jump
	if (NanoSuit_Player_Active[id] == 0 &&
			pev(id, pev_button) & IN_JUMP &&
			!(pev(id, pev_oldbuttons) & IN_JUMP)
			&& pev(id, pev_flags) & FL_ONGROUND )
		setEnergy(id, get_pcvar_num(pcNanoSuit_Strength_Jump));

	return FMRES_IGNORED;
}

// Help
public NanoSuit_Help(id) {
	show_motd(id, "motd.txt", "=[UnO]= Crysis NanoSuit");

	return PLUGIN_HANDLED;
}

// get_user_money (Fakemeta)
#if cellbits == 32
	#define OFFSET_CSMONEY  115
#else
	#define OFFSET_CSMONEY  140
#endif

#define OFFSET_LINUX      5

stock fm_set_user_money(id, money, flash = 1) {
	set_pdata_int(id, OFFSET_CSMONEY, money, OFFSET_LINUX);

	message_begin(MSG_ONE, get_user_msgid("Money"), {0,0,0}, id);
	write_long(money);
	write_byte(flash);
	message_end();
}

stock fm_get_user_money(id) {
	return get_pdata_int(id, OFFSET_CSMONEY, OFFSET_LINUX);
}